## superlu 5.2.1%2Bdfsg1

=== debian/control ===
Source: superlu
Priority: optional
Section: devel
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper (>= 12),
 gcc (>= 3.0),
 gfortran,
 cmake,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
Standards-Version: 4.3.0
Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/
Vcs-Git: https://salsa.debian.org/science-team/superlu.git
Vcs-Browser: https://salsa.debian.org/science-team/superlu

Package: libsuperlu5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Direct solution of large, sparse systems of linear equations
 SuperLU is a general purpose library for the direct solution of
 large, sparse, nonsymmetric systems of linear equations on high
 performance machines.
 .
 The library is written in C and is callable from either C or Fortran.
 The library routines will perform an LU decomposition with partial
 pivoting and triangular system solves through forward and back
 substitution. The LU factorization routines can handle non-square
 matrices but the triangular solves are performed only for square
 matrices. The matrix columns may be preordered (before factorization)
 either through library or user supplied routines. This preordering
 for sparsity is completely separate from the factorization. Working
 precision iterative refinement subroutines are provided for improved
 backward stability. Routines are also provided to equilibrate the
 system, estimate the condition number, calculate the relative
 backward error, and estimate error bounds for the refined solutions.
 .
 This package contains the SuperLU shared library.

Package: libsuperlu-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsuperlu5 (= ${binary:Version}),
    libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
    ${misc:Depends}
Suggests: libsuperlu-doc
Conflicts: libsuperlu4-dev, libsuperlu3-dev
Description: Direct solution of large, sparse systems of linear equations
 Development files for SuperLU.
 .
 SuperLU is a general purpose library for the direct solution of
 large, sparse, nonsymmetric systems of linear equations on high
 performance machines.
 .
 The library is written in C and is callable from either C or Fortran.
 The library routines will perform an LU decomposition with partial
 pivoting and triangular system solves through forward and back
 substitution. The LU factorization routines can handle non-square
 matrices but the triangular solves are performed only for square
 matrices. The matrix columns may be preordered (before factorization)
 either through library or user supplied routines. This preordering
 for sparsity is completely separate from the factorization. Working
 precision iterative refinement subroutines are provided for improved
 backward stability. Routines are also provided to equilibrate the
 system, estimate the condition number, calculate the relative
 backward error, and estimate error bounds for the refined solutions.
 .
 This package contains the header and development files to build
 against SuperLU.

Package: libsuperlu-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libsuperlu-dev
Description: Documentation for SuperLU
 This package contains the user guide and the reference manual of SuperLU.
 It also includes some example programs.

## superlu 5.2.1+dfsg1

=== CMakeLists.txt ===
######################################################################
#
# CMakeLists.txt for SUPERLU
#
######################################################################

# Required version
cmake_minimum_required(VERSION 2.8.12)

# Project Version	
project(SuperLU NONE)
set(VERSION_MAJOR "5")
set(VERSION_MINOR "2")
set(VERSION_BugFix "1")
set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})

######################################################################
#
# IDEAS: xSDK standards module
MESSAGE("\nProcess XSDK defaults ...")
# SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
INCLUDE("cmake/XSDKDefaults.cmake")
######################################################################

######################################################################
#
# Usual initialization stuff
#
######################################################################
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")

if (BUILD_SHARED_LIBS)
  message("-- SuperLU will be built as a shared library.")
  set(PROJECT_NAME_LIB_EXPORT libsuperlu.so)
else()
  message("-- SuperLU will be built as a static library.")
  set(PROJECT_NAME_LIB_EXPORT libsuperlu.a)
endif()

enable_language(C)
enable_language (Fortran)
set(NOFORTRAN FALSE)
set(SUPERLU_VERSION "${PROJECT_VERSION}")
set(SUPERLU_REV "${PROJECT_REV}")

# The XSDK standard does not allow using internally built BLAS
if (USE_XSDK_DEFAULTS)
  set(enable_blaslib_DEFAULT OFF)
else()
  set(enable_blaslib_DEFAULT ON)
endif()

# setup options
option(enable_blaslib   "Build the CBLAS library" ${enable_blaslib_DEFAULT})
option(enable_matlabmex "Build the Matlab mex library" OFF)
option(enable_tests     "Build tests" ON)
option(enable_doc       "Build doxygen documentation" OFF)
option(enable_single    "Enable single precision library" ON)
option(enable_double    "Enable double precision library" ON)
option(enable_complex   "Enable complex precision library" ON)
option(enable_complex16 "Enable complex16 precision library" ON)
# option(enable_examples  "Build examples" ON)

# setup required compiler defines and options.
## add_definitions(-DPRNTlevel=0 -DAdd_)
## get_directory_property( DirDefs COMPILE_DEFINITIONS )
set(CMAKE_C_FLAGS "-DPRNTlevel=0 -DAdd_ ${CMAKE_C_FLAGS}")
set(CMAKE_C_FLAGS_RELEASE "-O3" CACHE STRING "")

######################################################################
#
# Find packages
#
######################################################################
#
#--------------------- BLAS ---------------------
if(NOT enable_blaslib)
  if (TPL_BLAS_LIBRARIES)
    set(BLAS_FOUND TRUE)
  else()
    find_package(BLAS)
    if (BLAS_FOUND)
      set(TPL_BLAS_LIBRARIES "${BLAS_LIBRARIES}" CACHE FILEPATH
        "Set from FindBLAS.cmake BLAS_LIBRARIES." FORCE)
    endif()
  endif()
endif()

if(BLAS_FOUND)
  message("-- Using TPL_BLAS_LIBRARIES='${TPL_BLAS_LIBRARIES}'")
  set(CMAKE_C_FLAGS "-DUSE_VENDOR_BLAS ${CMAKE_C_FLAGS}")
  set(BLAS_LIB ${TPL_BLAS_LIBRARIES})
  # fix up BLAS library name
  string (REPLACE ";" " " BLAS_LIB_STR "${BLAS_LIB}")
  set(BLAS_LIB_EXPORT ${BLAS_LIB_STR})
else()
  message("-- Did not find or specify BLAS so configure to build internal CBLAS ...")
  add_subdirectory(CBLAS)
  set(BLAS_LIB blas)
  if (BUILD_SHARED_LIBS)  # export to be referenced by downstream makefile
      set(BLAS_LIB_EXPORT ${CMAKE_SOURCE_DIR}/build/CBLAS/libblas.so)
  else()
      set(BLAS_LIB_EXPORT ${CMAKE_SOURCE_DIR}/build/CBLAS/libblas.a)
  endif()
endif()


######################################################################
#
# Include directories
#
######################################################################

include_directories(${CMAKE_SOURCE_DIR}/SRC)

######################################################################
#
# Add subdirectories
#
######################################################################

add_subdirectory(SRC)

if(enable_matlabmex)
  add_subdirectory(MATLAB)
endif()

if(enable_tests)
  enable_testing()
  add_subdirectory(TESTING)
endif()

if(enable_doc)
  message(FATAL_ERROR "Documentation build requested but not implemented.")
  #implement doxygen
endif()


# file(WRITE "make.defs" "# can be exposed to users"
#  ${CMAKE_C_COMPILER}  )
configure_file(${CMAKE_SOURCE_DIR}/make.inc.in ${CMAKE_SOURCE_DIR}/make.inc)

=== CBLAS/CMakeLists.txt ===
set(headers 
    f2c.h
    slu_Cnames.h
)
set(sources "")

if (enable_single)
    list(APPEND sources
      isamax.c
      sasum.c
      saxpy.c
      scopy.c
      sdot.c
      snrm2.c
      srot.c 
      sscal.c 
      sswap.c
      sgemv
      ssymv
      strsv
      sger
      ssyr2
    )
endif()

if (enable_double)
    list(APPEND sources
      idamax.c
      dasum.c
      daxpy.c
      dcopy.c
      ddot.c
      dnrm2.c
      drot.c
      dscal.c
      dswap.c
      dgemv.c
      dsymv.c
      dtrsv.c
      dger.c
      dsyr2.c
    )
endif()

if (enable_complex)
    list(APPEND sources
      icamax.c
      scasum.c
      caxpy.c
      ccopy.c
      scnrm2.c
      cscal.c
      cswap.c
      cdotc.c
      cgemv.c
      chemv.c
      ctrsv.c
      cgerc.c
      cher2.c
    )
endif()

if (enable_complex16)
    list(APPEND sources
      izamax.c
      dzasum.c
      zaxpy.c
      zcopy.c
      dznrm2.c
      zscal.c
      dcabs1.c
      zswap.c
      zdotc.c
      zgemv.c
      zhemv.c
      ztrsv.c
      zgerc.c
      zher2.c
    )
endif()

add_library(blas ${sources} ${HEADERS})

=== SRC/CMakeLists.txt ===

set(headers 
    supermatrix.h
    slu_Cnames.h
    slu_dcomplex.h
    slu_scomplex.h
    slu_util.h
    superlu_enum_consts.h)

set(sources
  superlu_timer.c
  util.c
  memory.c
  get_perm_c.c
  mmd.c
  sp_coletree.c
  sp_preorder.c
  sp_ienv.c
  relax_snode.c
  heap_relax_snode.c
  colamd.c
  ilu_relax_snode.c
  ilu_heap_relax_snode.c
  mark_relax.c
  mc64ad.c
  qselect.c
  input_error.c
)
set_source_files_properties(superlu_timer.c PROPERTIES COMPILE_FLAGS -O0)

if(enable_single)
  list(APPEND headers
    slu_sdefs.h
  )

  list(APPEND sources
    slacon2.c
    smach.c
    sgssv.c
    sgssvx.c
    ssp_blas2.c
    ssp_blas3.c
    sgscon.c
    slangs.c
    sgsequ.c
    slaqgs.c
    spivotgrowth.c
    sgsrfs.c
    sgstrf.c
    sgstrs.c
    scopy_to_ucol.c
    ssnode_dfs.c
    ssnode_bmod.c
    spanel_dfs.c
    spanel_bmod.c
    sreadhb.c
    sreadrb.c
    sreadtriple.c
    scolumn_dfs.c
    scolumn_bmod.c
    spivotL.c
    spruneL.c
    smemory.c
    sutil.c
    smyblas2.c
    sgsisx.c
    sgsitrf.c
    sldperm.c
    ilu_sdrop_row.c
    ilu_ssnode_dfs.c
    ilu_scolumn_dfs.c
    ilu_spanel_dfs.c
    ilu_scopy_to_ucol.c
    ilu_spivotL.c
    sdiagonal.c
  )
  set_source_files_properties(smach.c PROPERTIES COMPILE_FLAGS -O0)
endif()

if(enable_double)
  list(APPEND headers
    slu_ddefs.h
  )

  list(APPEND sources
    dlacon2.c
    dmach.c
    dgssv.c
    dgssvx.c
    dsp_blas2.c
    dsp_blas3.c
    dgscon.c
    dlangs.c
    dgsequ.c
    dlaqgs.c
    dpivotgrowth.c
    dgsrfs.c
    dgstrf.c
    dgstrs.c
    dcopy_to_ucol.c
    dsnode_dfs.c
    dsnode_bmod.c
    dpanel_dfs.c
    dpanel_bmod.c
    dreadhb.c
    dreadrb.c
    dreadtriple.c
    dcolumn_dfs.c
    dcolumn_bmod.c
    dpivotL.c
    dpruneL.c
    dmemory.c
    dutil.c
    dmyblas2.c
    dgsisx.c
    dgsitrf.c
    dldperm.c
    ilu_ddrop_row.c
    ilu_dsnode_dfs.c
    ilu_dcolumn_dfs.c
    ilu_dpanel_dfs.c
    ilu_dcopy_to_ucol.c
    ilu_dpivotL.c
    ddiagonal.c
  )
  set_source_files_properties(dmach.c PROPERTIES COMPILE_FLAGS -O0)
endif()

if(enable_complex)
  list(APPEND headers
    slu_cdefs.h
  )

  list(APPEND sources
    clacon2.c
    scsum1.c
    icmax1.c
    scomplex.c
    cgssv.c
    cgssvx.c
    csp_blas2.c
    csp_blas3.c
    cgscon.c
    clangs.c
    cgsequ.c
    claqgs.c
    cpivotgrowth.c
    cgsrfs.c
    cgstrf.c
    cgstrs.c
    ccopy_to_ucol.c
    csnode_dfs.c
    csnode_bmod.c
    cpanel_dfs.c
    cpanel_bmod.c
    creadhb.c
    creadrb.c
    creadtriple.c
    ccolumn_dfs.c
    ccolumn_bmod.c
    cpivotL.c
    cpruneL.c
    cmemory.c
    cutil.c
    cmyblas2.c
    cgsisx.c
    cgsitrf.c
    cldperm.c
    ilu_cdrop_row.c
    ilu_csnode_dfs.c
    ilu_ccolumn_dfs.c
    ilu_cpanel_dfs.c
    ilu_ccopy_to_ucol.c
    ilu_cpivotL.c
    cdiagonal.c
  )
endif()

if(enable_complex16)
  list(APPEND headers
    slu_zdefs.h
  )

  list(APPEND sources
    zlacon2.c
    dzsum1.c
    izmax1.c
    dcomplex.c
    zgssv.c
    zgssvx.c
    zsp_blas2.c
    zsp_blas3.c
    zgscon.c
    zlangs.c
    zgsequ.c
    zlaqgs.c
    zpivotgrowth.c
    zgsrfs.c
    zgstrf.c
    zgstrs.c
    zcopy_to_ucol.c
    zsnode_dfs.c
    zsnode_bmod.c
    zpanel_dfs.c
    zpanel_bmod.c
    zreadhb.c
    zreadrb.c
    zreadtriple.c
    zcolumn_dfs.c
    zcolumn_bmod.c
    zpivotL.c
    zpruneL.c
    zmemory.c
    zutil.c
    zmyblas2.c
    zgsisx.c
    zgsitrf.c
    zldperm.c
    ilu_zdrop_row.c
    ilu_zsnode_dfs.c
    ilu_zcolumn_dfs.c
    ilu_zpanel_dfs.c
    ilu_zcopy_to_ucol.c
    ilu_zpivotL.c
    zdiagonal.c
  )
endif()

add_library(superlu ${sources} ${HEADERS})

target_link_libraries(superlu ${BLAS_LIB} m)
set_target_properties(superlu PROPERTIES
  VERSION ${PROJECT_VERSION} SOVERSION ${VERSION_MAJOR}
  )

include(GNUInstallDirs)

install(TARGETS superlu
#  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
  DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(FILES ${headers}
#  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== SRC/Makefile ===
# makefile for sparse supernodal LU, implemented in ANSI C
include ../make.inc

#######################################################################
#  This is the makefile to create a library for SuperLU.
#  The files are organized as follows:
#
#       ALLAUX -- Auxiliary routines called from all precisions of SuperLU
#	SLUSRC -- Single precision real SuperLU routines
#       DLUSRC -- Double precision real SuperLU routines
#	CLUSRC -- Single precision complex SuperLU routines
#       ZLUSRC -- Double precision complex SuperLU routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single double
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       superlu.a
#  and is created at the next higher directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################

### return machine parameters
SCAUX 	= smach.o
DZAUX 	= dmach.o

### SuperLU 
ALLAUX 	= superlu_timer.o util.o memory.o get_perm_c.o mmd.o \
	  sp_coletree.o sp_preorder.o sp_ienv.o relax_snode.o \
	  heap_relax_snode.o colamd.o \
	  ilu_relax_snode.o ilu_heap_relax_snode.o mark_relax.o \
	  mc64ad.o qselect.o input_error.o smach.o dmach.o

SLUSRC = \
	sgssv.o sgssvx.o \
	ssp_blas2.o ssp_blas3.o sgscon.o  \
	slangs.o sgsequ.o slaqgs.o spivotgrowth.o \
	sgsrfs.o sgstrf.o sgstrs.o scopy_to_ucol.o \
	ssnode_dfs.o ssnode_bmod.o \
	spanel_dfs.o spanel_bmod.o \
	sreadhb.o sreadrb.o sreadtriple.o \
	scolumn_dfs.o scolumn_bmod.o spivotL.o spruneL.o \
	smemory.o sutil.o smyblas2.o \
	sgsisx.o sgsitrf.o sldperm.o \
	ilu_sdrop_row.o ilu_ssnode_dfs.o \
	ilu_scolumn_dfs.o ilu_spanel_dfs.o ilu_scopy_to_ucol.o \
	ilu_spivotL.o sdiagonal.o slacon2.o

DLUSRC = \
	dgssv.o dgssvx.o \
	dsp_blas2.o dsp_blas3.o dgscon.o \
	dlangs.o dgsequ.o dlaqgs.o dpivotgrowth.o  \
	dgsrfs.o dgstrf.o dgstrs.o dcopy_to_ucol.o \
	dsnode_dfs.o dsnode_bmod.o dpanel_dfs.o dpanel_bmod.o \
	dreadhb.o dreadrb.o dreadtriple.o \
	dcolumn_dfs.o dcolumn_bmod.o dpivotL.o dpruneL.o \
	dmemory.o dutil.o dmyblas2.o \
	dgsisx.o dgsitrf.o dldperm.o \
	ilu_ddrop_row.o ilu_dsnode_dfs.o \
	ilu_dcolumn_dfs.o ilu_dpanel_dfs.o ilu_dcopy_to_ucol.o \
	ilu_dpivotL.o ddiagonal.o dlacon2.o
        ## dgstrsL.o dgstrsU.o

CLUSRC = \
	scomplex.o cgssv.o cgssvx.o csp_blas2.o csp_blas3.o cgscon.o \
	clangs.o cgsequ.o claqgs.o cpivotgrowth.o  \
	cgsrfs.o cgstrf.o cgstrs.o ccopy_to_ucol.o \
	csnode_dfs.o csnode_bmod.o \
	cpanel_dfs.o cpanel_bmod.o \
	creadhb.o creadrb.o creadtriple.o \
	ccolumn_dfs.o ccolumn_bmod.o cpivotL.o cpruneL.o \
	cmemory.o cutil.o cmyblas2.o \
	cgsisx.o cgsitrf.o cldperm.o \
	ilu_cdrop_row.o ilu_csnode_dfs.o \
	ilu_ccolumn_dfs.o ilu_cpanel_dfs.o ilu_ccopy_to_ucol.o \
	ilu_cpivotL.o cdiagonal.o clacon2.o scsum1.o icmax1.o

ZLUSRC = \
	dcomplex.o zgssv.o zgssvx.o zsp_blas2.o zsp_blas3.o zgscon.o \
	zlangs.o zgsequ.o zlaqgs.o zpivotgrowth.o  \
	zgsrfs.o zgstrf.o zgstrs.o zcopy_to_ucol.o \
	zsnode_dfs.o zsnode_bmod.o \
	zpanel_dfs.o zpanel_bmod.o \
	zreadhb.o zreadrb.o zreadtriple.o \
	zcolumn_dfs.o zcolumn_bmod.o zpivotL.o zpruneL.o \
	zmemory.o zutil.o zmyblas2.o \
	zgsisx.o zgsitrf.o zldperm.o \
	ilu_zdrop_row.o ilu_zsnode_dfs.o \
	ilu_zcolumn_dfs.o ilu_zpanel_dfs.o ilu_zcopy_to_ucol.o \
	ilu_zpivotL.o zdiagonal.o zlacon2.o dzsum1.o izmax1.o

all:    single double complex complex16

single: $(SLUSRC) $(ALLAUX) $(SCAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) $(SLUSRC) $(ALLAUX) $(SCAUX)
	$(RANLIB) $(SUPERLULIB)

double: $(DLUSRC) $(ALLAUX) $(DZLAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) $(DLUSRC) $(ALLAUX) $(DZLAUX)
	$(RANLIB) $(SUPERLULIB)

complex: $(CLUSRC) $(ALLAUX) $(SCAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) $(CLUSRC) $(ALLAUX) $(SCAUX)
	$(RANLIB) $(SUPERLULIB)

complex16: $(ZLUSRC) $(ALLAUX) $(DZLAUX)
	$(ARCH) $(ARCHFLAGS) $(SUPERLULIB) $(ZLUSRC) $(ALLAUX) $(DZLAUX)
	$(RANLIB) $(SUPERLULIB)

##################################

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) $(BLASDEF) -c $< $(VERBOSE)

.f.o:
	$(FORTRAN) $(FFLAGS) -c $<

clean:	
	rm -f *.o $(SUPERLULIB)

=== TESTING/CMakeLists.txt ===
include_directories(${SuperLU_SOURCE_DIR}/SRC)

# Libs linked to all of the tests
set(test_link_libs superlu matgen ${BLAS_LIB} m)

add_subdirectory(MATGEN)

set(ALINTST sp_ienv.c)
set(NVAL   9 19)
set(NRHS   2)
set(LWORK  0 10000000)

function(cat IN_FILE OUT_FILE)
  file(READ ${IN_FILE} CONTENTS)
  file(APPEND ${OUT_FILE} "${CONTENTS}")
endfunction()


function(add_superlu_test output input target)
  set(TEST_INPUT "${SuperLU_SOURCE_DIR}/EXAMPLE/${input}")
  set(TEST_OUTPUT "${SuperLU_BINARY_DIR}/TESTING/${output}")

  # Prepare a temporary file to "cat" to:
  # "== LAPACK test matrices"
  file(WRITE ${TEST_OUTPUT} "")

##  get_target_property(TEST_LOC ${target} LOCATION)
  set(TEST_LOC ${CMAKE_CURRENT_BINARY_DIR})

  foreach (n ${NVAL})
    foreach (s ${NRHS})
      foreach(l ${LWORK})
          set(testName "${target}_${n}_${s}_${l}")
	  set(SINGLE_OUTPUT ${SuperLU_BINARY_DIR}/TESTING/${testName}.out)
          add_test( ${testName}_LA  "${CMAKE_COMMAND}"
	    -DTEST=${TEST_LOC} -t "LA" -n ${n} -s ${s} -l ${l}
	    -DOUTPUT=${SINGLE_OUTPUT}
	    -DALL_OUTPUT=${TEST_OUTPUT}
	    -DHEADING=Dense\ matrix\ --\ n=${n},\ s=${s},\ lwork=${l}
	    -P "${SuperLU_SOURCE_DIR}/TESTING/runtest.cmake"
	  )
      endforeach()
    endforeach()
  endforeach()

#  file(APPEND ${TEST_OUTPUT} "== sparse matrix\n")

  foreach (s ${NRHS})
      foreach(l ${LWORK})
          set(testName "${target}_${s}_${l}")
	  set(SINGLE_OUTPUT ${SuperLU_BINARY_DIR}/TESTING/${testName}.out)
          add_test( ${testName}_SP  "${CMAKE_COMMAND}"
	    -DTEST=${TEST_LOC} -t "SP" -s ${s} -l ${l} -f ${TEST_INPUT}
	    -DOUTPUT=${SINGLE_OUTPUT}
	    -DALL_OUTPUT=${TEST_OUTPUT}
	    -DHEADING=Sparse\ matrix\ ${TEST_INPUT}\ --\ s=${s},\ lwork=${l}
	    -P "${SuperLU_SOURCE_DIR}/TESTING/runtest.cmake")
      endforeach()
  endforeach()

endfunction(add_superlu_test)


if(enable_single)
  set(SLINTST sdrive.c sp_sconvert.c sgst01.c sgst02.c sgst04.c sgst07.c)

  add_executable(s_test ${ALINTST} ${SLINTST})
  target_link_libraries(s_test ${test_link_libs})

  add_superlu_test(s_test.out g20.rua s_test)

endif()


if(enable_double)
  set(DLINTST ddrive.c sp_dconvert.c dgst01.c dgst02.c dgst04.c dgst07.c)

  add_executable(d_test ${ALINTST} ${DLINTST})
  target_link_libraries(d_test ${test_link_libs})

  add_superlu_test(d_test.out g20.rua d_test)
endif()

if(enable_complex)
  set(CLINTST cdrive.c sp_cconvert.c cgst01.c cgst02.c cgst04.c cgst07.c)

  add_executable(c_test ${ALINTST} ${CLINTST})
  target_link_libraries(c_test ${test_link_libs})

  add_superlu_test(c_test.out cg20.cua c_test)
endif()


if(enable_complex16)
  set(ZLINTST zdrive.c sp_zconvert.c zgst01.c zgst02.c zgst04.c zgst07.c)

  add_executable(z_test ${ALINTST} ${ZLINTST})
  target_link_libraries(z_test ${test_link_libs})

  add_superlu_test(z_test.out cg20.cua z_test)
endif()

=== TESTING/Makefile ===
include ../make.inc

#######################################################################
#  This makefile creates the test programs for the linear equation
#  routines in SuperLU.  The test files are grouped as follows:
#
#       ALINTST -- Auxiliary test routines
#       SLINTST -- Single precision real test routines
#       DLINTST -- Double precision real test routines
#       CLINTST -- Double precision complex test routines
#       ZLINTST -- Double precision complex test routines
#
#  Test programs can be generated for all or some of the four different
#  precisions.  Enter make followed by one or more of the data types
#  desired.  Some examples:
#       make single
#       make single double
#  Alternatively, the command
#       make
#  without any arguments creates all four test programs.
#  The executable files are called
#       stest
#       dtest
#       ctest
#       ztest
#
#  To remove the object files after the executable files have been
#  created, enter
#       make clean
#  On some systems, you can force the source files to be recompiled by
#  entering (for example)
#       make single FRC=FRC
#
#######################################################################

HEADER  = ../SRC

ALINTST = sp_ienv.o

SLINTST = sdrive.o sp_sconvert.o sgst01.o sgst02.o sgst04.o sgst07.o 

DLINTST = ddrive.o sp_dconvert.o dgst01.o dgst02.o dgst04.o dgst07.o 

CLINTST = cdrive.o sp_cconvert.o cgst01.o cgst02.o cgst04.o cgst07.o

ZLINTST = zdrive.o sp_zconvert.o zgst01.o zgst02.o zgst04.o zgst07.o

all: testmat single double complex complex16

testmat:
	(cd MATGEN; $(MAKE))

single: ./stest stest.out

./stest: $(SLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(SLINTST) $(ALINTST) \
        $(TMGLIB) $(LIBS) -lm -o $@

stest.out: stest stest.csh
	@echo Testing SINGLE PRECISION linear equation routines 
	csh stest.csh

double: ./dtest dtest.out

./dtest: $(DLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(DLINTST) $(ALINTST) \
        $(TMGLIB) $(LIBS) -lm -o $@

dtest.out: dtest dtest.csh
	@echo Testing DOUBLE PRECISION linear equation routines 
	csh dtest.csh

complex: ./ctest ctest.out

./ctest: $(CLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(CLINTST) $(ALINTST) \
	$(TMGLIB) $(LIBS) -lm -o $@

ctest.out: ctest ctest.csh
	@echo Testing SINGLE COMPLEX linear equation routines 
	csh ctest.csh

complex16: ./ztest ztest.out

./ztest: $(ZLINTST) $(ALINTST) $(SUPERLULIB) $(TMGLIB)
	$(LOADER) $(LOADOPTS) $(ZLINTST) $(ALINTST) \
	$(TMGLIB) $(LIBS) -lm -o $@

ztest.out: ztest ztest.csh
	@echo Testing DOUBLE COMPLEX linear equation routines 
	csh ztest.csh

##################################
# Do not optimize this routine   #
##################################
dlamch.o: dlamch.c ; $(CC) -c $<

timer.o:  timer.c ; $(CC) -O -c $<

.c.o:
	$(CC) $(CFLAGS) $(CDEFS) -I$(HEADER) -c $< $(VERBOSE)

clean:	
	rm -f *.o *test *.out

=== TESTING/MATGEN/CMakeLists.txt ===
set(sources "")

if(enable_single)
  list(APPEND sources
    slatm1.c
    slaran.c
    slarnd.c
    slaruv.c
    slabad.c
    slarnv.c
    slatb4.c
    slaset.c
    slartg.c
    slatms.c
    slagge.c
    slagsy.c
    slarge.c
    slaror.c
    slarot.c
    slatm2.c
    slatm3.c
    r_lg10.c
    r_sign.c
    pow_dd.c
    pow_ri.c
  )
endif()

if(enable_double)
  list(APPEND sources
    dlatm1.c
    dlaran.c
    dlarnd.c
    dlaruv.c
    dlabad.c
    dlarnv.c
    dlatb4.c
    dlaset.c
    dlartg.c
    dlatms.c
    dlagge.c
    dlagsy.c
    dlarge.c
    dlaror.c
    dlarot.c
    dlatm2.c
    dlatm3.c
    d_lg10.c
    d_sign.c
    pow_dd.c
    pow_di.c
  )
endif()

if(enable_complex)
  list(APPEND sources
    clatb4.c
    claset.c
    clartg.c
    clarnv.c
    clacgv.c
    csymv.c
    clatms.c
    clagge.c
    clagsy.c
    clarge.c
    claror.c
    clarot.c
    clatm2.c
    clatm3.c
    claghe.c
    clarnd.c
    cdotc.c
  )
endif()

if(enable_complex16)
  list(APPEND sources
    zlatb4.c
    zlaset.c
    zlartg.c
    zlarnv.c
    zlacgv.c
    zsymv.c
    zlatms.c
    zlagge.c
    zlagsy.c
    zlarge.c
    zlaror.c
    zlarot.c
    zlatm2.c
    zlatm3.c
    zlaghe.c
    zlarnd.c
    zdotc.c
  )
endif()

add_library(matgen ${sources})

=== TESTING/MATGEN/Makefile ===
include ../../make.inc

#######################################################################
#  This is the makefile to create a library of the test matrix
#  generators used in LAPACK.  The files are organized as follows:
#
#     SCATGEN  -- Auxiliary routines called from both REAL and COMPLEX
#     DZATGEN  -- Auxiliary routines called from both DOUBLE PRECISION
#                 and COMPLEX*16
#     SMATGEN  -- Single precision real matrix generation routines
#     CMATGEN  -- Single precision complex matrix generation routines
#     DMATGEN  -- Double precision real matrix generation routines
#     ZMATGEN  -- Double precision complex matrix generation routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#  The library is called
#       libtmglib.a
#  and is created at the LAPACK directory level.
#
#  To remove the object files after the library is created, enter
#       make clean
#
#######################################################################

SCATGEN = slatm1.o slaran.o slarnd.o slaruv.o slabad.o slarnv.o
SLASRC  = slatb4.o slaset.o slartg.o
SMATGEN = slatms.o slagge.o slagsy.o slarge.o slaror.o slarot.o slatm2.o slatm3.o
SINTRINSIC  = r_lg10.o r_sign.o pow_dd.o pow_ri.o

DZATGEN = dlatm1.o dlaran.o dlarnd.o dlaruv.o dlabad.o dlarnv.o
DLASRC  = dlatb4.o dlaset.o dlartg.o
DMATGEN = dlatms.o dlagge.o dlagsy.o dlarge.o dlaror.o dlarot.o dlatm2.o dlatm3.o
DINTRINSIC  = d_lg10.o d_sign.o pow_dd.o pow_di.o

CLASRC  = clatb4.o claset.o clartg.o clarnv.o clacgv.o csymv.o
CMATGEN = clatms.o clagge.o clagsy.o clarge.o claror.o clarot.o clatm2.o clatm3.o \
	  claghe.o clarnd.o
 #cdotc.o  already in BLAS

ZLASRC  = zlatb4.o zlaset.o zlartg.o zlarnv.o zlacgv.o zsymv.o
ZMATGEN = zlatms.o zlagge.o zlagsy.o zlarge.o zlaror.o zlarot.o zlatm2.o zlatm3.o \
	  zlaghe.o zlarnd.o
 #zdotc.o  in BLAS

all: single double complex complex16

single: $(SMATGEN) $(SCATGEN) $(SLASRC) $(SINTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(SMATGEN) $(SCATGEN) \
	        $(SLASRC) $(SINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

double: $(DMATGEN) $(DZATGEN) $(DLASRC) $(DINTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(DMATGEN) $(DZATGEN) \
	        $(DLASRC) $(DINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

complex: $(CMATGEN) $(SCATGEN) $(CLASRC) $(SINTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(CMATGEN) $(SCATGEN) \
	        $(CLASRC) $(SINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

complex16: $(ZMATGEN) $(DZATGEN) $(ZLASRC) $(DINSTRINSIC) $(ALLAUX)
	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(ZMATGEN) $(DZATGEN) \
	        $(ZLASRC) $(DINTRINSIC) $(ALLAUX)
	$(RANLIB) ../$(TMGLIB)

clean:
	rm -f *.o ../$(TMGLIB)

.c.o: ; $(CC) $(CFLAGS) $(CDEFS) -c $<

=== debian/changelog ===
superlu (5.2.1+dfsg1-4) unstable; urgency=medium

  * libsuperlu-dev depends on optimised BLAS from OpenBLAS or ATLAS
    where available.
  * add debian/tests (autopkgtest)
  * Standards-Version: 4.3.0
  * debhelper compatibility level 12
    - update doc-base entry: docs from doc package are now installed
      in the dev package dir /usr/share/doc/libsuperlu-dev
  * debian/rules: drop unnecessary --parallel flag for dh
  * debian/control: update Vcs tags to salsa.debian.org
  * mark libsuperlu-doc as Multi-Arch: foreign

 -- Drew Parsons <dparsons@debian.org>  Wed, 23 Jan 2019 18:10:37 +0100

superlu (5.2.1+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * Add spacing to package descriptions. Closes: #266560.
  * Standards-Version: 4.1.1
  * debhelper compatibility level 10

 -- Drew Parsons <dparsons@debian.org>  Mon, 06 Nov 2017 16:06:59 +0800

superlu (5.2.1+dfsg1-2) unstable; urgency=medium

  * Thanks Christophe Prud'homme for your contributions to the earlier
    versions of superlu.  Updating the Uploaders list now.
    Closes: #835010.
  * Upload superlu 5 to unstable. Closes: #823213.

 -- Drew Parsons <dparsons@debian.org>  Sat, 03 Sep 2016 10:10:01 +0800

superlu (5.2.1+dfsg1-1~exp1) experimental; urgency=medium
  
  * Team upload.

  [ Nico Schlömer ]
  * Update to SuperLU 5.2.1.
    - new ABI (soname 5)
  * Use CMake build.
  * Migrate from libsuperlu-dbg to ddebs, bump debhelper build-dependency

  [ Drew Parsons ]
  * debian/patches/gnuinstalldirs.patch now applied upstream

 -- Drew Parsons <dparsons@debian.org>  Sat, 28 May 2016 12:12:29 +0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
   -DBUILD_SHARED_LIBS:BOOL=ON \
   -Denable_blaslib:BOOL=OFF \
   -DCMAKE_INSTALL_INCLUDEDIR:PATH=include/superlu/


DEB_SOURCE_PACKAGE = superlu
DEB_UPSTREAM_VERSION = $(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -n -e 's/+dfsg.*$$//p')

get-orig-source:
	uscan --force-download --verbose --check-dirname-level 0 --download-version $(DEB_STRIPPED_UPSTREAM_VERSION) --upstream-version $(DEB_STRIPPED_UPSTREAM_VERSION) --repack --compression xz

override_dh_strip:
	dh_strip --dbgsym-migration='libsuperlu5-dbg (<< 5.2.1+dfsg1-1~)'

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1 \
http://crd-legacy.lbl.gov/~xiaoye/SuperLU/superlu_(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## superlu 5.2.2%2Bdfsg1

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//,repacksuffix=+dfsg1, \
 filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%superlu-$1.tar.gz%" \
 https://github.com/xiaoyeli/superlu/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## superlu 5.2.2+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 project(SuperLU NONE)
 set(VERSION_MAJOR "5")
 set(VERSION_MINOR "2")
-set(VERSION_BugFix "1")
+set(VERSION_BugFix "2")
 set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 ######################################################################
@@ -20,6 +20,8 @@
 MESSAGE("\nProcess XSDK defaults ...")
 # SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
 INCLUDE("cmake/XSDKDefaults.cmake")
+INCLUDE(CTest)
+
 ######################################################################
 
 ######################################################################
@@ -30,6 +32,23 @@
 set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
 set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
 
+#---- For shared library
+
+# use, i.e. don't skip the full RPATH for the build tree
+SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
+
+# when building, don't use the install RPATH already
+# (but later on when installing)
+SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+
+# the RPATH to be used when installing
+set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+
+# add the automatically determined parts of the RPATH
+# which point to directories outside the build tree to the install RPATH
+SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+#----
+
 if (BUILD_SHARED_LIBS)
   message("-- SuperLU will be built as a shared library.")
   set(PROJECT_NAME_LIB_EXPORT libsuperlu.so)
@@ -39,8 +58,10 @@
 endif()
 
 enable_language(C)
-enable_language (Fortran)
-set(NOFORTRAN FALSE)
+if (XSDK_ENABLE_Fortran)
+  enable_language (Fortran)
+  set(NOFORTRAN FALSE)
+endif()
 set(SUPERLU_VERSION "${PROJECT_VERSION}")
 set(SUPERLU_REV "${PROJECT_REV}")
 
@@ -51,8 +72,12 @@
   set(enable_blaslib_DEFAULT ON)
 endif()
 
+if (NOT CMAKE_INSTALL_PREFIX)
+  set(CMAKE_INSTALL_PREFIX /usr/local)
+endif()
+
 # setup options
-option(enable_blaslib   "Build the CBLAS library" ${enable_blaslib_DEFAULT})
+option(enable_internal_blaslib  "Build the CBLAS library" ${enable_blaslib_DEFAULT})
 option(enable_matlabmex "Build the Matlab mex library" OFF)
 option(enable_tests     "Build tests" ON)
 option(enable_doc       "Build doxygen documentation" OFF)
@@ -65,7 +90,7 @@
 # setup required compiler defines and options.
 ## add_definitions(-DPRNTlevel=0 -DAdd_)
 ## get_directory_property( DirDefs COMPILE_DEFINITIONS )
-set(CMAKE_C_FLAGS "-DPRNTlevel=0 -DAdd_ ${CMAKE_C_FLAGS}")
+set(CMAKE_C_FLAGS "-DPRNTlevel=0 -DDEBUGlevel=0 ${CMAKE_C_FLAGS}")
 set(CMAKE_C_FLAGS_RELEASE "-O3" CACHE STRING "")
 
 ######################################################################
@@ -75,7 +100,7 @@
 ######################################################################
 #
 #--------------------- BLAS ---------------------
-if(NOT enable_blaslib)
+if(NOT enable_internal_blaslib)
   if (TPL_BLAS_LIBRARIES)
     set(BLAS_FOUND TRUE)
   else()
@@ -99,20 +124,11 @@
   add_subdirectory(CBLAS)
   set(BLAS_LIB blas)
   if (BUILD_SHARED_LIBS)  # export to be referenced by downstream makefile
-      set(BLAS_LIB_EXPORT ${CMAKE_SOURCE_DIR}/build/CBLAS/libblas.so)
+      set(BLAS_LIB_EXPORT ${CMAKE_INSTALL_PREFIX}/CBLAS/libblas.so)
   else()
-      set(BLAS_LIB_EXPORT ${CMAKE_SOURCE_DIR}/build/CBLAS/libblas.a)
+      set(BLAS_LIB_EXPORT ${CMAKE_INSTALL_PREFIX}/CBLAS/libblas.a)
   endif()
 endif()
-
-
-######################################################################
-#
-# Include directories
-#
-######################################################################
-
-include_directories(${CMAKE_SOURCE_DIR}/SRC)
 
 ######################################################################
 #
@@ -136,8 +152,11 @@
   #implement doxygen
 endif()
 
-
 # file(WRITE "make.defs" "# can be exposed to users"
 #  ${CMAKE_C_COMPILER}  )
-configure_file(${CMAKE_SOURCE_DIR}/make.inc.in ${CMAKE_SOURCE_DIR}/make.inc)
+# configure_file(${CMAKE_SOURCE_DIR}/make.inc.in ${CMAKE_SOURCE_DIR}/make.inc)
+configure_file(${SuperLU_SOURCE_DIR}/make.inc.in ${SuperLU_SOURCE_DIR}/make.inc)
  
+configure_file(${CMAKE_CURRENT_SOURCE_DIR}/superlu.pc.in ${CMAKE_CURRENT_BINARY_DIR}/superlu.pc @ONLY)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/superlu.pc
+	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== Makefile ===
############################################################################
#
#  Program:         SuperLU
#
#  Module:          Makefile
#
#  Purpose:         Top-level Makefile
#
#  Creation date:   October 2, 1995
#
#  Modified:        February 4,  1997  Version 1.0
#		    November 15, 1997  Version 1.1
#		    September 1, 1999  Version 2.0
#		    October 15,  2003  Version 3.0
#		    August 1,    2008  Version 3.1
#
############################################################################

include make.inc

all: install lib testing

lib: superlulib tmglib

clean: cleanlib cleantesting

install:
	( cd INSTALL; $(MAKE) )
#	( cd INSTALL; cp lsame.c ../SRC/; \
#	  cp dlamch.c ../SRC/; cp slamch.c ../SRC/ )

blaslib:
	( cd CBLAS; $(MAKE) )

superlulib:
	( cd SRC; $(MAKE) )

tmglib:
	( cd TESTING/MATGEN; $(MAKE) )

matlabmex:
	( cd MATLAB; $(MAKE) )

testing:
	( cd TESTING ; $(MAKE) )

doc:
	doxygen Doxyfile

cleanlib:
	( cd SRC; $(MAKE) clean )
	( cd TESTING/MATGEN; $(MAKE) clean )
	( cd CBLAS; $(MAKE) clean )

cleantesting:
	( cd INSTALL; $(MAKE) clean )
	( cd TESTING; $(MAKE) clean )
	( cd MATLAB;  $(MAKE) clean )
	( cd EXAMPLE; $(MAKE) clean )
	( cd FORTRAN; $(MAKE) clean )

=== SRC/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,4 @@
-
-set(headers 
+set(headers
     supermatrix.h
     slu_Cnames.h
     slu_dcomplex.h
@@ -25,6 +24,8 @@
   mc64ad.c
   qselect.c
   input_error.c
+  dmach.c
+  smach.c
 )
 set_source_files_properties(superlu_timer.c PROPERTIES COMPILE_FLAGS -O0)
 
@@ -56,6 +57,7 @@
     sreadhb.c
     sreadrb.c
     sreadtriple.c
+    sreadMM.c
     scolumn_dfs.c
     scolumn_bmod.c
     spivotL.c
@@ -105,6 +107,7 @@
     dreadhb.c
     dreadrb.c
     dreadtriple.c
+    dreadMM.c
     dcolumn_dfs.c
     dcolumn_bmod.c
     dpivotL.c
@@ -122,6 +125,7 @@
     ilu_dcopy_to_ucol.c
     ilu_dpivotL.c
     ddiagonal.c
+    dGetDiagU.c
   )
   set_source_files_properties(dmach.c PROPERTIES COMPILE_FLAGS -O0)
 endif()
@@ -156,6 +160,7 @@
     creadhb.c
     creadrb.c
     creadtriple.c
+    creadMM.c
     ccolumn_dfs.c
     ccolumn_bmod.c
     cpivotL.c
@@ -206,6 +211,7 @@
     zreadhb.c
     zreadrb.c
     zreadtriple.c
+    zreadMM.c
     zcolumn_dfs.c
     zcolumn_bmod.c
     zpivotL.c
@@ -227,20 +233,59 @@
 endif()
 
 add_library(superlu ${sources} ${HEADERS})
-
-target_link_libraries(superlu ${BLAS_LIB} m)
+target_link_libraries(superlu PUBLIC ${BLAS_LIB})
+if (NOT WIN32)
+  target_link_libraries(superlu PUBLIC m)
+endif ()
+target_include_directories(superlu PUBLIC
+  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
+  $<INSTALL_INTERFACE:include>
+  )
 set_target_properties(superlu PROPERTIES
   VERSION ${PROJECT_VERSION} SOVERSION ${VERSION_MAJOR}
   )
 
+# Define GNU standard installation directories
 include(GNUInstallDirs)
 
 install(TARGETS superlu
-#  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib
-  DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  EXPORT superluTargets
+  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
 )
 
 install(FILES ${headers}
-#  DESTINATION ${CMAKE_INSTALL_PREFIX}/include
   DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
 )
+
+include(CMakePackageConfigHelpers)
+write_basic_package_version_file(
+  superluConfigVersion.cmake
+  VERSION ${PACKAGE_VERSION}
+  COMPATIBILITY SameMajorVersion
+  )
+
+install(EXPORT superluTargets
+  FILE superluTargets.cmake
+  NAMESPACE superlu::
+  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/superlu"
+  )
+
+configure_package_config_file(
+  superluConfig.cmake.in superluConfig.cmake
+  INSTALL_DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/superluConfig.cmake"
+  )
+install(
+  FILES
+      "${CMAKE_CURRENT_BINARY_DIR}/superluConfig.cmake"
+      "${CMAKE_CURRENT_BINARY_DIR}/superluConfigVersion.cmake"
+  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/superlu"
+  )
+
+export(EXPORT superluTargets
+  FILE "${CMAKE_CURRENT_BINARY_DIR}/superluTargets.cmake"
+  NAMESPACE superlu::
+  )
+
+export(PACKAGE superlu)

=== TESTING/MATGEN/CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,24 @@
 set(sources "")
-
-if(enable_single)
-  list(APPEND sources
+set(SCATGEN
     slatm1.c
     slaran.c
     slarnd.c
     slaruv.c
     slabad.c
     slarnv.c
+)
+set(DZATGEN
+    dlatm1.c
+    dlaran.c
+    dlarnd.c
+    dlaruv.c
+    dlabad.c
+    dlarnv.c
+)
+
+if(enable_single)
+  list(APPEND sources ${SCATGEN})
+  list(APPEND sources
     slatb4.c
     slaset.c
     slartg.c
@@ -27,13 +38,8 @@
 endif()
 
 if(enable_double)
+  list(APPEND sources ${DZATGEN})
   list(APPEND sources
-    dlatm1.c
-    dlaran.c
-    dlarnd.c
-    dlaruv.c
-    dlabad.c
-    dlarnv.c
     dlatb4.c
     dlaset.c
     dlartg.c
@@ -53,6 +59,7 @@
 endif()
 
 if(enable_complex)
+  list(APPEND sources ${SCATGEN})
   list(APPEND sources
     clatb4.c
     claset.c
@@ -70,11 +77,16 @@
     clatm3.c
     claghe.c
     clarnd.c
-    cdotc.c
-  )
+#    cdotc.c
+    r_lg10.c
+    r_sign.c
+    pow_dd.c
+    pow_ri.c
+)
 endif()
 
 if(enable_complex16)
+  list(APPEND sources ${DZATGEN})
   list(APPEND sources
     zlatb4.c
     zlaset.c
@@ -92,8 +104,13 @@
     zlatm3.c
     zlaghe.c
     zlarnd.c
-    zdotc.c
+#    zdotc.c
+    d_lg10.c
+    d_sign.c
+    pow_dd.c
+    pow_di.c
   )
 endif()
 
 add_library(matgen ${sources})
+target_link_libraries(matgen superlu)

=== TESTING/MATGEN/Makefile ===
--- 
+++ 
@@ -52,24 +52,24 @@
 
 all: single double complex complex16
 
-single: $(SMATGEN) $(SCATGEN) $(SLASRC) $(SINTRINSIC) $(ALLAUX)
+single: $(SMATGEN) $(SCATGEN) $(SLASRC) $(SINTRINSIC)
 	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(SMATGEN) $(SCATGEN) \
-	        $(SLASRC) $(SINTRINSIC) $(ALLAUX)
+	        $(SLASRC) $(SINTRINSIC)
 	$(RANLIB) ../$(TMGLIB)
 
-double: $(DMATGEN) $(DZATGEN) $(DLASRC) $(DINTRINSIC) $(ALLAUX)
+double: $(DMATGEN) $(DZATGEN) $(DLASRC) $(DINTRINSIC)
 	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(DMATGEN) $(DZATGEN) \
-	        $(DLASRC) $(DINTRINSIC) $(ALLAUX)
+	        $(DLASRC) $(DINTRINSIC)
 	$(RANLIB) ../$(TMGLIB)
 
-complex: $(CMATGEN) $(SCATGEN) $(CLASRC) $(SINTRINSIC) $(ALLAUX)
+complex: $(CMATGEN) $(SCATGEN) $(CLASRC) $(SINTRINSIC)
 	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(CMATGEN) $(SCATGEN) \
-	        $(CLASRC) $(SINTRINSIC) $(ALLAUX)
+	        $(CLASRC) $(SINTRINSIC)
 	$(RANLIB) ../$(TMGLIB)
 
-complex16: $(ZMATGEN) $(DZATGEN) $(ZLASRC) $(DINSTRINSIC) $(ALLAUX)
+complex16: $(ZMATGEN) $(DZATGEN) $(ZLASRC) $(DINSTRINSIC)
 	$(ARCH) $(ARCHFLAGS) ../$(TMGLIB) $(ZMATGEN) $(DZATGEN) \
-	        $(ZLASRC) $(DINTRINSIC) $(ALLAUX)
+	        $(ZLASRC) $(DINTRINSIC)
 	$(RANLIB) ../$(TMGLIB)
 
 clean:

=== debian/changelog ===
superlu (5.2.2+dfsg1-2) unstable; urgency=medium

  * upload SuperLU 5.2.2 to unstable.

 -- Drew Parsons <dparsons@debian.org>  Fri, 23 Oct 2020 17:46:16 +0800

superlu (5.2.2+dfsg1-1exp1) experimental; urgency=medium

  * update debian/watch and Homepage to
    https://github.com/xiaoyeli/superlu
  * New upstream release.
  * Standards-Version: 4.5.0
  * debhelper compatibility level 13.
    Build-Depends: debhelper-compat (= 13)
  * update internal BLAS configuration to enable_internal_blaslib=OFF
    with -DTPL_BLAS_LIBRARIES=blas (common BLAS library, specific
    fast implementation controlled by blas alternatives)
  * libsuperlu-dev provides cmake and pkgconfig config files
  * skip RPATH: don't embed RUNPATH into shared library

 -- Drew Parsons <dparsons@debian.org>  Tue, 20 Oct 2020 18:30:14 +0800

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Section: devel
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>
-Build-Depends: debhelper (>= 12),
+Build-Depends: debhelper-compat (= 13),
  gcc (>= 3.0),
  gfortran,
  cmake,
  libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
-Standards-Version: 4.3.0
-Homepage: http://crd-legacy.lbl.gov/~xiaoye/SuperLU/
+Standards-Version: 4.5.0
+Homepage: https://github.com/xiaoyeli/superlu
 Vcs-Git: https://salsa.debian.org/science-team/superlu.git
 Vcs-Browser: https://salsa.debian.org/science-team/superlu
